CWIS Developer Documentation

- Home
- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
ClassificationFactory Class Reference

Factory for producing and manipulating Classification objects. More...

Inheritance diagram for ClassificationFactory:
[legend]
Collaboration diagram for ClassificationFactory:
[legend]

## Public Member Functions
| __construct ($FieldId=NULL)
| Class constructor. More...
| GetChildIds ($ClassId)
| Get IDs of all children of specified classification. More...
| RecalculateAllResourceCounts ()
| Queue tasks to recalculate resource counts for all classifications. More...
| FindMatchingRecentlyUsedValues ($SearchString, $NumberOfResults=5, $IdExclusions=array(), $ValueExclusions=array())
| Retrieve recently used items matching a search string. More...
Public Member Functions inherited from ItemFactory
| __construct ($ItemClassName, $ItemTableName, $ItemIdColumnName, $ItemNameColumnName=NULL, $OrderOpsAllowed=FALSE, $SqlCondition=NULL)
| Class constructor. More...
| GetItemClassName ()
| Get class name of items manipulated by factory. More...
| CleanOutStaleTempItems ($MinutesUntilStale=10080)
| Clear out (call the Delete() method) for any temp items more than specified number of minutes old. More...
| GetNextItemId ()
| Retrieve next available (non-temp) item ID. More...
| GetHighestItemId ($IgnoreSqlCondition=FALSE)
| Retrieve highest item ID in use. More...
| GetNextTempItemId ()
| Return next available temporary item ID. More...
| GetItemCount ($Condition=NULL, $IncludeTempItems=FALSE)
| Get count of items. More...
| GetItemIds ($Condition=NULL, $IncludeTempItems=FALSE, $SortField=NULL, $SortAscending=TRUE)
| Return array of item IDs. More...
| GetLatestModificationDate ($Condition=NULL)
| Get newest modification date (based on values in "DateLastModified" column in database table). More...
| GetItem ($ItemId)
| Retrieve item by item ID. More...
| ItemExists ($ItemId, $IgnoreSqlCondition=FALSE)
| Check that item exists with specified ID. More...
| GetItemByName ($Name, $IgnoreCase=FALSE)
| Retrieve item by name. More...
| GetItemIdByName ($Name, $IgnoreCase=FALSE)
| Retrieve item ID by name. More...
| GetItemIdsByNames ($Names)
| Look up IDs for specified names. More...
| GetItemNames ($SqlCondition=NULL)
| Retrieve item names. More...
| GetItems ($SqlCondition=NULL)
| Retrieve items. More...
| GetItemsAsOptionList ($OptionListName, $SelectedItemId=NULL, $SqlCondition=NULL, $DisplaySize=1, $SubmitOnChange=FALSE, $Disabled=FALSE)
| Retrieve items of specified type as HTML option list with item names as labels and item IDs as value attributes. More...
| NameIsInUse ($Name, $IgnoreCase=FALSE)
| Check whether item name is currently in use. More...
| SearchForItemNames ($SearchString, $NumberOfResults=100, $IncludeVariants=FALSE, $UseBooleanMode=TRUE, $Offset=0, $IdExclusions=array(), $NameExclusions=array())
| Retrieve items with names matching search string. More...
| GetCountForItemNames ($SearchString, $IncludeVariants=FALSE, $UseBooleanMode=TRUE, $IdExclusions=array(), $NameExclusions=array())
| Retrieve count of items with names matching search string. More...
| ReindexByItemIds ($Array)
| Reindex supplied associative array, by replacing item names with item IDs. More...
| CachingEnabled ($NewValue=NULL)
| Enable/disable caching of item information. More...
| ClearCaches ()
| Clear item information caches. More...
| SetOrderOpsCondition ($Condition)
| Set SQL condition (added to WHERE clause) used to select items for ordering operations. More...
| InsertBefore ($TargetItem, $NewItem)
| Insert item into order before specified item. More...
| InsertAfter ($TargetItem, $NewItem)
| Insert item into order after specified item. More...
| Prepend ($Item)
| Add item to beginning of order. More...
| Append ($Item)
| Add item to end of order. More...
| GetItemIdsInOrder ()
| Retrieve list of item IDs in order. More...
| RemoveItemFromOrder ($ItemId)
| Remove item from existing order. More...

## Static Public Member Functions
static | RecalculateResourceCount ($Id)
| Callback to recalculate the resource count for a single classification by its ID. More...
static | PruneClassificationsToTopLevel ($Classes)
| Prune list of classifications back to just their top level. More...

## Additional Inherited Members
Protected Attributes inherited from ItemFactory
| $DB

## Detailed Description

Factory for producing and manipulating Classification objects.

See also
  ItemFactory

Definition at line 14 of file ClassificationFactory.php.

## Constructor & Destructor Documentation

ClassificationFactory::__construct | ( |  | $FieldId = `NULL` | ) |

Class constructor.

Parameters

  int | $FieldId | ID of metadata field for classification.

Definition at line 23 of file ClassificationFactory.php.

## Member Function Documentation

ClassificationFactory::FindMatchingRecentlyUsedValues | ( |  | $SearchString,
|  |  | $NumberOfResults = `5`,
|  |  | $IdExclusions = `array()`,
|  |  | $ValueExclusions = `array()`
| ) |  |

Retrieve recently used items matching a search string.

Parameters

  string | $SearchString | String to match
  int | $NumberOfResults | Number of results to return. (OPTIONAL, defaults to 5)
  array | $IdExclusions | List of IDs of items to exclude.
  array | $ValueExclusions | List of names of items to exclude.

Returns
  array List of item names, with item IDs for index.

Definition at line 88 of file ClassificationFactory.php.

ClassificationFactory::GetChildIds | ( |  | $ClassId | ) |

Get IDs of all children of specified classification.

Parameters

  int | $ClassId | ID of classification.

Returns
  array IDs of all child classifications.

Definition at line 37 of file ClassificationFactory.php.

References ItemFactory\$DB.

static ClassificationFactory::PruneClassificationsToTopLevel | ( |  | $Classes | ) |
| static

Prune list of classifications back to just their top level.

Parameters

  array | $Classes | Array to prune, with classification IDs for the index.

Returns
  array Pruned list of full classification names with the corresponding classificaton IDs for the index.

Definition at line 156 of file ClassificationFactory.php.

References Classification\FullName().

ClassificationFactory::RecalculateAllResourceCounts | ( |  | ) |

Queue tasks to recalculate resource counts for all classifications.

Definition at line 65 of file ClassificationFactory.php.

References ItemFactory\GetItemIds(), and ApplicationFramework\PRIORITY_BACKGROUND.

static ClassificationFactory::RecalculateResourceCount | ( |  | $Id | ) |
| static

Callback to recalculate the resource count for a single classification by its ID.

Parameters

  int | $Id | ID of the classification for which to recalculate the count.

Definition at line 134 of file ClassificationFactory.php.

The documentation for this class was generated from the following file:

- objects/ClassificationFactory.php